"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var mutate_op_1 = require("../enums/mutate-op");
var mutate_type_1 = require("../enums/mutate-type");
var artificial_pooled_selection_1 = require("../populations/artificial-pooled-selection");
var gOptions = {
    geneLength: 1,
    genomeLength: 20,
    length: 6,
    loopGenes: true,
};
var pOptions = {
    initSize: 9,
    maxParentPoolSize: 5,
    maxSize: 10,
    minParentPoolSize: 2,
    minSize: 5,
    mutateOptions: {
        mutateChance: 0.15,
        mutateOp: mutate_op_1.MutateOp.avg,
        sampleSize: 1,
        type: mutate_type_1.MutateType.normal,
    },
};
var create = function (genome) {
    return _.range(gOptions.length)
        .map(function (i) {
        return genome.g.letter();
    });
};
var pop = new artificial_pooled_selection_1.ArtificialPooledSelection(pOptions, gOptions, create);
pop.keep();
//# sourceMappingURL=pooled.js.map