"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var fill_type_1 = require("../enums/fill-type");
var fitness_objective_1 = require("../enums/fitness-objective");
var mutate_op_1 = require("../enums/mutate-op");
var mutate_type_1 = require("../enums/mutate-type");
var reproduce_type_1 = require("../enums/reproduce-type");
var index_1 = require("../index");
function createList(genome) {
    return _.range(0, genome.options.length)
        .map(function (i) {
        var n = genome.g;
        i = n.int(genome.options.min, genome.options.max);
        return genome.g.int(genome.options.min, genome.options.max);
    });
}
function fitness(genome) {
    var target = 100;
    var list = createList(index_1.replenish(genome));
    var sum = _.sum(list);
    var fit = Math.abs(target - sum);
    return { fitness: fit, genome: genome, result: list };
}
var gOptions = {
    geneLength: 5,
    genomeLength: 3,
    length: 3,
    loopGenes: true,
    max: 100,
    min: 1,
};
var pOptions = {
    fillPercent: 0.25,
    fillType: fill_type_1.FillType.none,
    mutateOptions: {
        mutateChance: 0.15,
        mutateOp: mutate_op_1.MutateOp.sub,
        sampleSize: 5,
        type: mutate_type_1.MutateType.safeSampled,
    },
    objective: fitness_objective_1.FitnessObjective.minimize,
    populationSize: 20,
    reproduceOptions: {
        sampleSize: 5,
        type: reproduce_type_1.ReproduceType.normal,
    },
};
var pop = new index_1.NaturalSelection(pOptions, gOptions, createList, fitness);
var ev = pop.evolve$()
    .subscribe(function (e) {
    var list = e.result;
    var f = e.fitness;
    // do something with list
});
//# sourceMappingURL=sum.js.map