"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var gene_1 = require("genotypes/gene");
var _ = require("lodash");
var genome_1 = require("../genotypes/genome");
// randomly replaces a percent of genomes (regardless of fitness) with random ones
function fillRandom(genomes, percent) {
    if (percent > 1 || percent < 0) {
        throw new Error(("percent must be a number between 0 (inclusive) and 1 (inclusive)"));
    }
    var removed = new gene_1.Gene(percent).elements(_.shuffle(genomes));
    var culled = genomes.filter(function (g) { return !_.includes(removed, g); });
    var random = _.range(removed.length).map(function (i) { return new genome_1.Genome(genomes[0].options); });
    var filled = _.concat(culled, random);
    return filled;
}
exports.fillRandom = fillRandom;
//# sourceMappingURL=fill-random.js.map