"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var index_1 = require("../index");
// replaces the worst genomes with random ones
function fillWorst(genomes, fitness, percent) {
    if (percent > 1 || percent < 0) {
        throw new Error(("percent must be a decimal between (0, 1)"));
    }
    var removed = index_1.bottom(genomes, fitness, percent).map(function (e) { return e.genome; });
    var culled = genomes.filter(function (g) { return !_.includes(removed, g); });
    var random = _.range(removed.length).map(function (i) { return new index_1.Genome(genomes[0].options); });
    var filled = _.concat(culled, random);
    return filled;
}
exports.fillWorst = fillWorst;
//# sourceMappingURL=fill-worst.js.map