"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var genome_1 = require("../genotypes/genome");
var reproduce_1 = require("./reproduction/reproduce");
function fill(gens, n) {
    // create offspring to fill array with
    var offspring = _.range(0, n - gens.length)
        .map(function (i) {
        var g = new genome_1.Genome(gens[0].options);
        // select two random parents, and create an offspring using two random weights
        var p1 = g.g.element(gens);
        var p2 = g.g.element(gens);
        var w1 = g.g.float(0, 1);
        var w2 = g.g.float(0, 1);
        return reproduce_1.reproduce(p1, p2, w1, w2);
    });
    return _.concat(gens, offspring);
}
exports.fill = fill;
//# sourceMappingURL=fill.js.map