"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var fitness_objective_1 = require("../../enums/fitness-objective");
var mutate_op_1 = require("../../enums/mutate-op");
var index_1 = require("../../index");
function safeMutateMany(genomes, fitness, objective, mutateChance, mutateType) {
    if (objective === void 0) { objective = fitness_objective_1.FitnessObjective.maximize; }
    if (mutateChance === void 0) { mutateChance = 0.05; }
    if (mutateType === void 0) { mutateType = mutate_op_1.MutateOp.sub; }
    var result = [];
    switch (objective) {
        case fitness_objective_1.FitnessObjective.maximize:
            while (result.length < genomes.length) {
                result = _.concat(result, index_1.mutateMany(genomes, mutateChance, mutateType)
                    .filter(function (g) { return fitness(g).fitness > index_1.avgFitness(genomes, fitness); }));
            }
        case fitness_objective_1.FitnessObjective.minimize:
            while (result.length < genomes.length) {
                result = _.concat(result, index_1.mutateMany(genomes, mutateChance, mutateType)
                    .filter(function (g) { return fitness(g).fitness < index_1.avgFitness(genomes, fitness); }));
            }
    }
    return result.slice(0, genomes.length);
}
exports.safeMutateMany = safeMutateMany;
//# sourceMappingURL=safe-mutate-many.js.map