"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fitness_objective_1 = require("../../enums/fitness-objective");
var mutate_op_1 = require("../../enums/mutate-op");
var best_1 = require("../best");
var worst_1 = require("../worst");
var mutate_1 = require("./mutate");
// returns a mutated genome unless the original genome is more fit, in which case, it returns the original genome
function safeMutate(gen, fitness, objective, mutateChance, mutateType) {
    if (objective === void 0) { objective = fitness_objective_1.FitnessObjective.maximize; }
    if (mutateChance === void 0) { mutateChance = 0.05; }
    if (mutateType === void 0) { mutateType = mutate_op_1.MutateOp.sub; }
    var mutant = mutate_1.mutate(gen, mutateChance, mutateType);
    switch (objective) {
        case fitness_objective_1.FitnessObjective.maximize:
            return best_1.best([gen, mutant], fitness).genome;
        case fitness_objective_1.FitnessObjective.minimize:
            return worst_1.worst([gen, mutant], fitness).genome;
    }
}
exports.safeMutate = safeMutate;
//# sourceMappingURL=safe-mutate.js.map