"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fitness_objective_1 = require("../../enums/fitness-objective");
var mutate_op_1 = require("../../enums/mutate-op");
var best_1 = require("../best");
var worst_1 = require("../worst");
var sampled_mutate_1 = require("./sampled-mutate");
function safeSampledMutate(gen, fitness, objective, sampleSize, mutateChance, mutateType) {
    if (objective === void 0) { objective = fitness_objective_1.FitnessObjective.maximize; }
    if (sampleSize === void 0) { sampleSize = 5; }
    if (mutateChance === void 0) { mutateChance = 0.05; }
    if (mutateType === void 0) { mutateType = mutate_op_1.MutateOp.sub; }
    var mutant = sampled_mutate_1.sampledMutate(gen, fitness, objective, sampleSize, mutateChance, mutateType);
    switch (objective) {
        case fitness_objective_1.FitnessObjective.maximize:
            return best_1.best([gen, mutant], fitness).genome;
        case fitness_objective_1.FitnessObjective.minimize:
            return worst_1.worst([gen, mutant], fitness).genome;
    }
}
exports.safeSampledMutate = safeSampledMutate;
//# sourceMappingURL=safe-sampled-mutate.js.map