"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var fitness_objective_1 = require("../../enums/fitness-objective");
var mutate_op_1 = require("../../enums/mutate-op");
var best_1 = require("../best");
var worst_1 = require("../worst");
var mutate_1 = require("./mutate");
function sampledMutateMany(genomes, fitness, objective, mutateChance, mutateType, sampleSize) {
    if (objective === void 0) { objective = fitness_objective_1.FitnessObjective.maximize; }
    if (mutateChance === void 0) { mutateChance = 0.05; }
    if (mutateType === void 0) { mutateType = mutate_op_1.MutateOp.sub; }
    if (sampleSize === void 0) { sampleSize = 5; }
    switch (objective) {
        case fitness_objective_1.FitnessObjective.maximize:
            return genomes.map(function (g) {
                var sample = _.range(0, sampleSize).map(function (i) { return mutate_1.mutate(g, mutateChance, mutateType); });
                return best_1.best(sample, fitness).genome;
            });
        case fitness_objective_1.FitnessObjective.minimize:
            return genomes.map(function (g) {
                var sample = _.range(0, sampleSize).map(function (i) { return mutate_1.mutate(g, mutateChance, mutateType); });
                return worst_1.worst(sample, fitness).genome;
            });
    }
}
exports.sampledMutateMany = sampledMutateMany;
//# sourceMappingURL=sampled-mutate-many.js.map