"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var fitness_objective_1 = require("../../enums/fitness-objective");
var mutate_op_1 = require("../../enums/mutate-op");
var best_1 = require("../best");
var worst_1 = require("../worst");
var mutate_1 = require("./mutate");
// produces a number of mutated genomes, then returns the best one.
function sampledMutate(gen, fitness, objective, sampleSize, mutateChance, mutateType) {
    if (objective === void 0) { objective = fitness_objective_1.FitnessObjective.maximize; }
    if (sampleSize === void 0) { sampleSize = 5; }
    if (mutateChance === void 0) { mutateChance = 0.05; }
    if (mutateType === void 0) { mutateType = mutate_op_1.MutateOp.sub; }
    var mutants = _.range(0, sampleSize)
        .map(function (i) { return mutate_1.mutate(gen, mutateChance, mutateType); });
    switch (objective) {
        case fitness_objective_1.FitnessObjective.maximize:
            return best_1.best(mutants, fitness).genome;
        case fitness_objective_1.FitnessObjective.minimize:
            return worst_1.worst(mutants, fitness).genome;
    }
}
exports.sampledMutate = sampledMutate;
//# sourceMappingURL=sampled-mutate.js.map