"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Chance = require("chance");
var _ = require("lodash");
var genome_1 = require("../../../genotypes/genome");
var value_1 = require("../../value");
var chance = new Chance();
function reproduceManyToOne(genomes, weights) {
    if (weights === void 0) { weights = _.range(0, genomes.length).map(function (i) { return value_1.value(); }); }
    var offspringSeq = _
        .zip.apply(_, genomes.map(function (g) { return g.sequence; })).map(function (slice) {
        return chance.weighted(slice, weights);
    });
    return new genome_1.Genome(chance.weighted(genomes, weights).options, offspringSeq);
}
exports.reproduceManyToOne = reproduceManyToOne;
//# sourceMappingURL=reproduce-many-to-one.js.map