"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chance_1 = require("chance");
var _ = require("lodash");
var mutate_op_1 = require("../../enums/mutate-op");
var genome_1 = require("../../genotypes/genome");
var mutate_1 = require("../mutation/mutate");
var chance = new chance_1.Chance();
function reproduce(gen1, gen2, weight1, weight2, mutateChance) {
    if (weight1 === void 0) { weight1 = 1; }
    if (weight2 === void 0) { weight2 = 1; }
    if (mutateChance === void 0) { mutateChance = 0.05; }
    return mutate_1.mutate(new genome_1.Genome(gen1.options, _.zip(gen1.sequence, gen2.sequence)
        .map(function (values) {
        // console.log(`w1: ${w1}, w2: ${w2}`);
        var v = chance.weighted(values, [weight1, weight2]);
        return v;
    })), mutateChance, mutate_op_1.MutateOp.avg);
}
exports.reproduce = reproduce;
//# sourceMappingURL=reproduce.js.map