"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fitness_objective_1 = require("../../enums/fitness-objective");
var best_1 = require("../best");
var worst_1 = require("../worst");
var reproduce_1 = require("./reproduce");
function safeReproduce(gen1, gen2, fitness, objective, weight1, weight2, mutateChance) {
    if (objective === void 0) { objective = fitness_objective_1.FitnessObjective.maximize; }
    if (weight1 === void 0) { weight1 = 1; }
    if (weight2 === void 0) { weight2 = 1; }
    if (mutateChance === void 0) { mutateChance = 0.05; }
    var offspring = reproduce_1.reproduce(gen1, gen2, weight1, weight2, mutateChance);
    switch (objective) {
        case fitness_objective_1.FitnessObjective.maximize:
            return best_1.best([gen1, gen2, offspring], fitness).genome;
        case fitness_objective_1.FitnessObjective.minimize:
            return worst_1.worst([gen1, gen2, offspring], fitness).genome;
    }
}
exports.safeReproduce = safeReproduce;
//# sourceMappingURL=safe-reproduce.js.map