import { Genome } from "../genotypes/genome";
import { IParent } from "../interfaces/parent";
import { IArtificialPooledSelectionOptions } from "../options/artificial-pooled-selection-options";
import { IGenomeOptions } from "../options/genome-options";
export declare class ArtificialPooledSelection<T extends IGenomeOptions, U extends IArtificialPooledSelectionOptions, V> {
    popOptions: U;
    genOptions: T;
    create: (gen: Genome<T>) => V;
    genomes: Array<Genome<T>>;
    parents: Array<IParent<T>>;
    constructor(popOptions: U, genOptions: T, create: (gen: Genome<T>) => V);
    readonly current: Genome<T>;
    readonly currentResult: V;
    keep(): void;
    kill(): void;
    reproduce(): void;
    delete(): void;
    random(): void;
    generate(): void;
    private produceOffspring();
    private ageParents(n?);
    private removeOldestParent();
    private add(genome);
    private addParent(genome);
    private shift(genome?);
    private remove(genome);
    private removeParent(parent);
}
