/// <reference types="rx-core" />
/// <reference types="rx-core-binding" />
/// <reference types="rx-lite" />
/// <reference types="rx-lite-aggregates" />
/// <reference types="rx-lite-backpressure" />
/// <reference types="rx-lite-coincidence" />
/// <reference types="rx-lite-experimental" />
/// <reference types="rx-lite-joinpatterns" />
/// <reference types="rx-lite-time" />
import { Observable } from "rx";
import { Genome } from "../genotypes/genome";
import { IArtificialSelectionOptions } from "../options/artificial-selection-options";
import { IGenomeOptions } from "../options/genome-options";
export declare class ArtificialSelection<T extends IGenomeOptions, U extends IArtificialSelectionOptions, V> {
    popOptions: U;
    genOptions: T;
    create: (gen: Genome<T>) => V;
    genomes: Array<Genome<T>>;
    private genomesSubject;
    readonly genomes$: Observable<Array<Genome<T>>>;
    constructor(popOptions: U, genOptions: T, create: (gen: Genome<T>) => V);
    readonly current: Genome<T>;
    readonly current$: Observable<Genome<T>>;
    keep(): void;
    kill(): void;
    reproduce(n?: number): void;
    delete(): void;
    random(): void;
    generate(): void;
    private refresh();
    private add(genome);
    private addRange(genomes);
    private insert(genome, index, delCount);
    private dequeue();
    private requeue();
    private remove(genome);
    private removeAtIndex(index);
}
