/// <reference types="rx-core" />
/// <reference types="rx-core-binding" />
/// <reference types="rx-lite" />
/// <reference types="rx-lite-aggregates" />
/// <reference types="rx-lite-backpressure" />
/// <reference types="rx-lite-coincidence" />
/// <reference types="rx-lite-experimental" />
/// <reference types="rx-lite-joinpatterns" />
/// <reference types="rx-lite-time" />
import { Observable } from "rx";
import { Genome, IEvaluation, IGenomeOptions, NaturalSelectionOptions } from "../index";
export declare class NaturalSelection<T extends IGenomeOptions, U extends NaturalSelectionOptions, V> {
    popOptions: U;
    genOptions: T;
    create: (gen: Genome<T>) => V;
    fitness: (gen: Genome<T>) => IEvaluation<T, V>;
    genomes: Array<Genome<T>>;
    constructor(popOptions: U, genOptions: T, create: (gen: Genome<T>) => V, fitness: (gen: Genome<T>) => IEvaluation<T, V>);
    reproduce(gens: Array<Genome<T>>): Array<Genome<T>>;
    mutate(gens: Array<Genome<T>>): Array<Genome<T>>;
    fill(gens: Array<Genome<T>>): Array<Genome<T>>;
    evolveStep(): Array<Genome<T>>;
    evolve(generations: number): IEvaluation<T, V>;
    evolve$(generations?: number, timeout?: number): Observable<IEvaluation<T, V>>;
}
